/* Copyright (C) 2013 Bruno Mascret
 * Contact: bmascret@free.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS sheFOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


/**
	Cette classe illustre le tp guidé sur la mémoire et les mécanismes de java
	http://bruno.mascret.fr/dokuwiki/doku.php?id=java:memoire&#les_types_primitifs
	@author Bruno Mascret

*/
public class Memoire{

	public static void types(){
		System.out.println("*********** Conversions ***********");
		byte b = -2;
		short s = 123;
		int i = 21456;
		long l = 3456123124L;//le L à la fin indique que c'est un long
		
		double d = 1452.4578;
		float f = 666.666666F;//le F à la fin indique que c'est un float
		
		
		char c = 'B';
		
		boolean bool = true;
		
		System.out.println("données:"+b+";"+s+";"+i+";"+l+";"+d+";"+f+";"+c+";"+bool);
		System.out.println(" 1) conversions sans pertes");
		
		s = b;
		i = s;
		l = i;
		d = i;
		System.out.println("données:"+b+";"+s+";"+i+";"+l+";"+d+";"+f+";"+c+";"+bool);
		l=c;
		System.out.println("données:"+b+";"+s+";"+i+";"+l+";"+d+";"+f+";"+c+";"+bool);
		/* error : incompatible type
		l=bool;
		*/
		
		System.out.println(" 2) conversions automatiques avec pertes possibles");
		f = i;//ça a l'air de fonctionner
		System.out.println(f+";"+i);
		i = 1456123124;
		f = i;//oups! ça ne fonctionne plus!!! Pourquoi?
		System.out.println(f+";"+i);
		
		System.out.println(" 3) conversions non autorisées par le compilateur");
		//erreurs de type "possible loss of precision
		//l = d; 
		//i = f;
		//erreurs de type "integer number too large"
		//i = 3456123124;
		
		System.out.println(" 4) conversions avec transtypage (cast)");
		l = 3456123124L;
		i = (int) l; //transtypage: plus d'erreur...
		System.out.println(i+";"+l);
		//... mais un résultat inexact!
		//... là ça marche 
		l = -2147483648L;
		i = (int) l;
		System.out.println(i+";"+l);
		//et là ça marche plus, on est à la limite: pourquoi?
		l = -2147483649L;
		i = (int) l;
		System.out.println(i+";"+l);
	}

	
	public static void main(String args[]){
		Memoire.types();
	}
}
