/* Copyright (C) 2013 Bruno Mascret
 * Contact: bmascret@free.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS sheFOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


/**
	Cette classe illustre le tp guidé sur la mémoire et les mécanismes de java
	pour les types construits
	http://bruno.mascret.fr/dokuwiki/doku.php?id=java:memoire&#les_types_pointeurs_types_construits_tableaux
	@author Bruno Mascret

*/
public class TypeConstruit{

	/**
		Méthode qui affiche l'adresse mémoire de différents Types construits en java
	*/
	public static void adresseMemoire(){
		//création d'une instance d'Object
		Object o = new Object();
		System.out.println(o);
		
		//tableau d'entiers
		int[] tabInt = new int[10];
		System.out.println(tabInt);
		
		//tableau de double
		double[] tabDouble = new double[10];
		System.out.println(tabDouble);
		
		//tableau d'Object
		Object[] tabObject = new Object[10];
		System.out.println(tabObject);
		
		Object[] tabObjectCopie = tabObject;
		System.out.println(tabObjectCopie);
		
		Object rien = null;//je n'utilise pas "new" ni une variable construite
		System.out.println(rien);
	}

	public static void amnesie(){
		Object o1 = new Object();
		Object o2 = new Animal("Serge");
		Object o3 = new Animal("Tryphon", "Pingouin");
		Object o4 = new Pingouin("Thérèse");
		/* ça marche pas!
		o4.jouer();
		o4.glisser();*/
		
		Animal a = (Animal)o4;
		a.jouer();
		
		((Pingouin)o4).glisser();
	}
	
	public static void main(String args[]){
		TypeConstruit.adresseMemoire();
		TypeConstruit.amnesie();
	}
}
